import java.util.Hashtable;
import java.util.Collection;
import java.util.Iterator;

class CellGroup {
	protected Hashtable cells;

	public CellGroup()
	{
		cells = new Hashtable();
	}

	public void Remove(PuzzleCell c)
	{
		for (Iterator it = cells.values().iterator(); it.hasNext(); )
		{
			PuzzleCell cell = (PuzzleCell) it.next();
			if (c != cell)
			{
				cell.Remove(c.CellValue());
			}
		}
	}

	public void Pull(int pullValue) 
	{
		// If pullValue is possible in only one cell, make it certain in that cell.

		PuzzleCell firstPossibility = null;

		for (Iterator it = cells.values().iterator();  it.hasNext(); )
		{
			PuzzleCell c = (PuzzleCell) it.next();
			if (c.IsPossible(pullValue)) 
			{
				if (null == firstPossibility) 
				{
					firstPossibility = c;
				} 
				else 
				{
					return;
				}
			}
		}

		firstPossibility.MakeCertain(pullValue);
	}
}