import java.util.Hashtable;
import java.util.Collection;

class PuzzleCell {
	protected Hashtable possibilities;
	protected PuzzleBlock block;
	protected PuzzleRow row;
	protected PuzzleColumn column;

	public PuzzleCell(int initValue)
	{
		possibilities = new Hashtable();
		if (0 == initValue) 
		{
			for(int i = 1;  i < 10;  i++) 
			{
				possibilities.put(i, i);
			}
		} 
		else 
		{
			possibilities.put(initValue, initValue);
		}
	}

	public void Remove(int rValue) 
	{
		possibilities.remove(rValue);
	}

	public boolean IsPossible(int checkValue) 
	{
		return (null != possibilities.get(checkValue));
	}

	public void MakeCertain(int initValue) 
	{
		possibilities = new Hashtable();
		possibilities.put(initValue, initValue);
	}

	public boolean isCertain() 
	{
		return (1 == possibilities.size());			
	}

	public int CellValue()
	{
		Collection c = possibilities.values();
		Object [] array = c.toArray();
		return (Integer) array[0];
	}

	public PuzzleColumn getColumn()
	{
		return column;
	}

	public void setColumn(PuzzleColumn c) 
	{
		column = c;
	}

	public PuzzleRow getRow()
	{
		return row;
	}

	public void setRow(PuzzleRow r)
	{
		row = r;
	}

	public PuzzleBlock getBlock()
	{
		return block;
	}

	public void setBlock(PuzzleBlock b) 
	{
		block = b;
	}
}
